unit DailySundial_Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Printers, Math;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ComboBox1: TComboBox;
    Label10: TLabel;
    Label11: TLabel;
    ComboBox2: TComboBox;
    Label12: TLabel;
    ComboBox3: TComboBox;
    Label13: TLabel;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    Button3: TButton;
    ComboBox6: TComboBox;
    Label14: TLabel;
    ComboBox7: TComboBox;
    GroupBox3: TGroupBox;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    procedure Calculate;
    function NormalizeTo360(V:double): double;
    function NormalizeTo180(V:double): double;
  public
    { Public declarations }
    procedure Render(Canvas: TCanvas; sizeX, sizeY, DPI: Integer);
  end;

const
  MINUTE_STEP = 5;

var
  Form1: TForm1;
  TimeZones: array[0..35] of Double;
  Angles: array [0 .. (24 * 60) div MINUTE_STEP] of real;
  Altitudes: array [0 .. (24 * 60) div MINUTE_STEP] of real;
implementation

uses DailySundial_Unit2;

{$R *.dfm}

procedure TForm1.Render(Canvas: TCanvas; sizeX, sizeY, DPI: Integer);
var  degreesToRadians, radiansToDegrees, a,f, sf: double;
     h, I, cx, cy, R, r1, eA, eB, dpcm, x, y, eA1, eB1,x3,y3,x4,y4:integer;
     s: string;
     f5,l5,f10,l10,f60,l60: double;
     s5, s10, s60: Boolean;
begin
  degreesToRadians := 3.141592 /  180.0000;
  radiansToDegrees := 180.0000 /    3.141592;
  cx := sizeX div 2;
  cy := sizeY div 2;
  dpcm := round ( DPI / 2.54 );
  with Canvas do begin
    Brush.Color := clWhite;
    FillRect(rect(0,0,sizeX,sizeY));
    //central target
    Pen.Color := clBlack; Pen.Style := psDot; Pen.Width := 1;
    i := dpcm div 2;
    Ellipse(cx - i, cy -i, cx + i, cy +i);
    i := dpcm;

    MoveTo(cx, cy - i); LineTo(cx, cy + i);
    MoveTo(cx, cy - i); LineTo(cx - dpcm div 4, cy - i + dpcm div 4);
    MoveTo(cx, cy - i); LineTo(cx + dpcm div 4, cy - i + dpcm div 4);
    MoveTo(cx, cy + i); LineTo(cx - dpcm div 4, cy + i - dpcm div 4);
    MoveTo(cx, cy + i); LineTo(cx + dpcm div 4, cy + i - dpcm div 4);

    MoveTo(cx - i, cy); LineTo(cx + i, cy);
    MoveTo(cx - i, cy); LineTo(cx - i + dpcm div 4, cy - dpcm div 4);
    MoveTo(cx - i, cy); LineTo(cx - i + dpcm div 4, cy + dpcm div 4);
    MoveTo(cx + i, cy); LineTo(cx + i - dpcm div 4, cy - dpcm div 4);
    MoveTo(cx + i, cy); LineTo(cx + i - dpcm div 4, cy + dpcm div 4);

    Font.Size := 10;
    Font.Style := Font.Style - [fsBold];
    x := TextWidth('North'); y := TextHeight('North');
    TextOut(cx - x div 2, cy - i - y - dpcm div 5, 'North');
    x := TextWidth('South'); y := TextHeight('South');
    TextOut(cx - x div 2, cy + i + dpcm div 5, 'South');
    // rays
    Pen.Color := clBlack; Pen.Style := psSolid;
    R := 2 * dpcm;
    eA := sizeX div 2 - 3 * dpcm;
    eB := sizeY div 2 - 3 * dpcm;
    //initialize borders
    s5 := False; s10 := False; s60 := False;
    for I := 0 to length(Angles) - 1 do begin
      if Angles[I] > -1000 then begin
        a := NormalizeTo360((270-Angles[I]));
        if (a > 90.0) and (a < 270.0) then sf := 3.141592
        else sf := 0;
        a := a * degreesToRadians;
        h := MINUTE_STEP * I;
        if (h mod 60 = 0) then begin
          Pen.Width := 4; r1 := 2 * dpcm div 3;
          if not s60 then begin
            f60 := a;
            s60:= True;
          end;
          l60 := a;
        end
        else if (h mod 30) = 0 then begin
          Pen.Width := 3; r1 := dpcm div 3;
        end
        else if (h mod 15) = 0 then begin
          Pen.Width := 2; r1 := 0;
          if not s5 then begin
            f5 := a;
            s5 := True;
          end;
          l5 := a;
        end
        else if (h mod 10) = 0 then begin
          Pen.Width := 1; r1 := dpcm div 3;
          if not s10 then begin
            f10 := a;
            s10 := True;
          end;
          l10 := a;
        end
        else begin
          Pen.Width := 1; r1 := 0;
          if not s5 then begin
            f5 := a;
            s5 := True;
          end;
          l5 := a;
        end;
        MoveTo(round(cx + R * Cos(a)),round(cy + R * Sin(a)));
        eA1 := eA + r1; eB1 := eB + r1;
        f := ArcTan((eA1 * Tan(a)) / eB1) + sf;
        LineTo(round(cx + eA1 * Cos(f) ),round(cy + eB1 * Sin(f)));
        if h mod 30 = 0  then begin
          if h mod 60 = 0 then begin
            s := IntToStr( h div 60) + ':00';
            Font.Size := 14;
            Font.Style := Font.Style + [fsBold];
          end
          else begin
            s := IntToStr( h div 60) + ':30';
            Font.Size := 10;
            Font.Style := Font.Style - [fsBold];
            r1 := r1 + dpcm div 3;
          end;
          x := TextWidth(s); y := TextHeight(s);
          r1 := r1 + x div 2 + dpcm div 5;
          eA1 := eA + r1; eB1 := eB + r1;
          f := ArcTan(Tan(a) * eA1 / eB1) + sf;
          TextOut(round(cx + eA1 * Cos(f) )- x div 2,round(cy + eB1 * Sin(f)) - y div 2, s)
        end;
      end;
    end;
    //borders
    Pen.Width := 4;
    r1 := 2 * dpcm div 3;
    eA1 := eA + r1 + 4; eB1 := eB + r1 + 4;
    if (f60 > 1.570796) and (f60 < 4.712388) then sf := 3.141592
    else sf := 0;
    f := ArcTan((eA1 * Tan(f60)) / eB1) + sf;
    x3 := round(cx + eA1 * Cos(f));
    y3 := round(cy + eB1 * Sin(f));
    if (l60 > 1.570796) and (l60 < 4.712388) then sf := 3.141592
    else sf := 0;
    f := ArcTan((eA1 * Tan(l60)) / eB1) + sf;
    x4 := round(cx + eA1 * Cos(f));
    y4 := round(cy + eB1 * Sin(f));
    if ComboBox6.Text = 'North' then begin
      x := x3; y := y3;
      x3 := x4; y3 := y4;
      x4 := x; y4 := y;
    end;
    Arc(cx - eA - r1,
        cy - eB - r1,
        cx + eA + r1,
        cy + eB + r1,
        x3, y3, x4, y4 );

    Pen.Width := 3;
    r1 := dpcm div 3;
    eA1 := eA + r1 + 3; eB1 := eB + r1 + 3;
    if (f10 > 1.570796) and (f10 < 4.712388) then sf := 3.141592
    else sf := 0;
    f := ArcTan((eA1 * Tan(f10)) / eB1) + sf;
    x3 := round(cx + eA1 * Cos(f));
    y3 := round(cy + eB1 * Sin(f));
    if (l10 > 1.570796) and (l10 < 4.712388) then sf := 3.141592
    else sf := 0;
    f := ArcTan((eA1 * Tan(l10)) / eB1) + sf;
    x4 := round(cx + eA1 * Cos(f));
    y4 := round(cy + eB1 * Sin(f));
    if ComboBox6.Text = 'North' then begin
      x := x3; y := y3;
      x3 := x4; y3 := y4;
      x4 := x; y4 := y;
    end;
    Arc(cx - eA - r1,
        cy - eB - r1,
        cx + eA + r1,
        cy + eB + r1,
        x3, y3, x4, y4 );

    Pen.Width := 1;
    r1 := 0;
    eA1 := eA + r1; eB1 := eB + r1;
    if (f5 > 1.570796) and (f5 < 4.712388) then sf := 3.141592
    else sf := 0;
    f := ArcTan((eA1 * Tan(f5)) / eB1) + sf;
    x3 := round(cx + eA1 * Cos(f));
    y3 := round(cy + eB1 * Sin(f));
    if (l5 > 1.570796) and (l5 < 4.712388) then sf := 3.141592
    else sf := 0;
    f := ArcTan((eA1 * Tan(l5)) / eB1) + sf;
    x4 := round(cx + eA1 * Cos(f));
    y4 := round(cy + eB1 * Sin(f));
    if ComboBox6.Text = 'North' then begin
      x := x3; y := y3;
      x3 := x4; y3 := y4;
      x4 := x; y4 := y;
    end;
    Arc(cx - eA - r1,
        cy - eB - r1,
        cx + eA + r1,
        cy + eB + r1,
        x3, y3, x4, y4 );
    // legend
    Font.Size := 10;
    Font.Style := Font.Style - [fsBold];
    s := 'Sundial valid at ' + Edit1.Text + ' degrees ' + ComboBox6.Text + ', ';
    s := s + Edit2.Text + ' degrees ' + ComboBox7.Text + ' on ' + ComboBox1.Text;
    s := s + ' ' + ComboBox5.Text + ' ' + ComboBox2.Text;
    x := TextWidth(s); y := TextHeight(s);
    TextOut(dpcm, sizey - dpcm - y, s);
    // watermark
    Font.Size := 10;
    Font.Style := Font.Style - [fsBold];
    s := '(c) 2006 by Ludd  ludd@qss.cz';
    x := TextWidth(s); y := TextHeight(s);
    TextOut(sizex - dpcm  - x, sizey - dpcm - y, s);
  end;
end;

function TForm1.NormalizeTo360(V:double): double;
begin
  result := (V - Floor (V / 360.0) * 360);
end;

function TForm1.NormalizeTo180(V:double): double;
begin
  V := NormalizeTo360 (V);
	if (V > 180) then V := V - 360;
	result := V;
end;


procedure TForm1.Calculate();
var
  degreesToRadians, radiansToDegrees,Longitude, Latitude,
  Elevation, Date, Year, TimeZone, daylightAdjustment, meridian,
  sunRiseSetLSoTMinutes, declination, obliquity, sunrise, sunset,
  L, alpha, t, G, MinutesAfterMidnight, HoursAfterMidnight, UT,
  Month, C, GHA, eotAdjustment, clockTimeToLSOTAdjustment,
  solarHourAngle, altitudeAngle, azimuthAngle, preazimuthAngle,
  hourAngle, solarMinutesAfterMidnight, zeroAzimuth: double;
  I: integer;
begin
  degreesToRadians := 3.141592 /  180.0000;
  radiansToDegrees := 180.0000 /    3.141592;
  Longitude := StrToFloat(Edit2.Text);
  Latitude := StrToFloat(Edit1.Text);
  Elevation := StrToFloat(Edit3.Text);
  Date := StrToFloat(ComboBox1.Text);
  Year := StrToFloat(ComboBox2.Text);
  TimeZone := TimeZones[ComboBox3.ItemIndex];

  zeroAzimuth := 0;

  if (Latitude  = 0) then Latitude  := 0.000000001;
  if (Longitude = 0) then Longitude := 0.000000001;

  if ComboBox7.Text = 'East' then Longitude := -Longitude;
  if ComboBox6.Text = 'South' then Latitude := - Latitude;

  if ComboBox4.Text = 'Yes' then daylightAdjustment := 1
  else daylightAdjustment := 0;

  meridian := TimeZone * -15.0;

  for I := 0 to length(Angles) - 1 do begin
    MinutesAfterMidnight := I * MINUTE_STEP;
    HoursAfterMidnight := MinutesAfterMidnight / 60.0;

    UT := HoursAfterMidnight - TimeZone - daylightAdjustment;

    Month := ComboBox5.ItemIndex + 1;
    if (Month > 2) then Month := Month - 3
    else begin
      Year := Year - 1;
      Month := Month  + 9;
    end;

    t := ((UT / 24.0) + Date + Floor(30.6 * Month + 0.5) + Floor(365.25 * (Year - 1976)) - 8707.5) / 36525.0;

	  G := 357.528 + 35999.05 * t;
    G := NormalizeTo360 (G);

	  C := (1.915 * Sin(G * degreesToRadians)) + (0.020 * Sin(2.0 * G * degreesToRadians));

    L := 280.460 + (36000.770 * t) + C;
	  L := NormalizeTo360 (L);

    alpha := L - 2.466 * Sin (2.0 * L * degreesToRadians) + 0.053 *
      Sin (4.0 * L * degreesToRadians);

    obliquity := 23.4393 - 0.013 * t;

    declination := ArcTan (Tan (obliquity * degreesToRadians) *
      Sin (alpha * degreesToRadians)) * radiansToDegrees;

    GHA := UT * 15.0 - 180.0 - C + L - alpha;
		GHA := NormalizeTo360 (GHA);

    eotAdjustment := (L - C - alpha) / 15.0;

    clockTimeToLSOTAdjustment := ((Longitude - meridian) / 15.0) - eotAdjustment + daylightAdjustment;

    solarHourAngle := GHA - Longitude;
    solarHourAngle := NormalizeTo180 (solarHourAngle);

    try
      sunRiseSetLSoTMinutes := radiansToDegrees * ArcCos(
        -1.0 *
        (Sin (Latitude * degreesToRadians) *
       Sin (declination    * degreesToRadians) -
       Sin ((-0.8333 - 0.0347 * Sqrt (Elevation)) * degreesToRadians)) /
       Cos (Latitude * degreesToRadians) /
       Cos (declination    * degreesToRadians)) * 4;

      Sunrise := 12 * 60 - sunRiseSetLSoTMinutes + (clockTimeToLSOTAdjustment * 60);
      Sunset := 12 * 60 + sunRiseSetLSoTMinutes + (clockTimeToLSOTAdjustment * 60);

    except
      Sunrise := 0;
      Sunset := 24 * 60;
    end;


    solarMinutesAfterMidnight := MinutesAfterMidnight - (clockTimeToLSOTAdjustment * 60.0);
    if (solarMinutesAfterMidnight < 0) then solarMinutesAfterMidnight := solarMinutesAfterMidnight + 24 * 60;
    if (solarMinutesAfterMidnight >= 24 * 60) then solarMinutesAfterMidnight := solarMinutesAfterMidnight - 24 * 60;


    hourAngle := (solarMinutesAfterMidnight - 12.0 * 60.0) / 4.0 * -1.0;


    altitudeAngle := radiansToDegrees  * ArcSin (
				(Sin (Latitude         * degreesToRadians)  *
				 Sin (declination            * degreesToRadians)) -
				(Cos (Latitude         * degreesToRadians)  *
				 Cos (declination            * degreesToRadians)  *
				 Cos ((solarHourAngle + 180.0) * degreesToRadians)));

    preAzimuthAngle := radiansToDegrees * ArcCos (
				(Cos (declination    * degreesToRadians)   *
				((Cos (Latitude * degreesToRadians)   *
				 Tan (declination    * degreesToRadians))   +
				 Sin (Latitude * degreesToRadians)   *
				 Cos ((solarHourAngle + 180.0) * degreesToRadians))) /
				 Cos (altitudeAngle  * degreesToRadians));

		if ((hourAngle > 0.0) and (hourAngle < 180.0)) then begin
      azimuthAngle := (360.0 - preAzimuthAngle) + (zeroAzimuth - 180.0);
    end
    else begin
     azimuthAngle := preAzimuthAngle + (zeroAzimuth - 180.0);
    end;
    if (MinutesAfterMidnight >= sunrise) and (MinutesAfterMidnight <= sunset) then begin
      Angles[I] := azimuthAngle;
      Altitudes[I] := altitudeAngle
    end
    else
      Angles[I] := -1000;

  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var printDialog: TPrintDialog;
    DPI:integer;
begin
  printDialog := TPrintDialog.Create(Form1);
  printDialog.MinPage := 1;
  printDialog.MaxPage := 1;
  if printDialog.Execute then begin
    Calculate;
    Printer.Orientation := poLandscape;
    DPI := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
    Printer.BeginDoc;
    Render(Printer.Canvas, Printer.PageWidth, Printer.PageHeight,DPI);
    Printer.EndDoc;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Application.Terminate();

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Calculate;
  Form2.ShowModal;
end;

procedure TForm1.FormCreate(Sender: TObject);
var I: integer;
  S: string  ;
  today: Tdatetime;
  T: double;
  TZ: TTimezoneinformation;
  r: TDateTime;
begin
  BorderStyle := bsSingle;
  BorderIcons := [biSystemMenu];

  today := date;

  Edit1.Text :=  '';
  Edit2.Text :=  '';
  Edit3.Text :=  '0';

  ComboBox6.Items.Add('North');
  ComboBox6.Items.Add('South');
  ComboBox6.Text := ComboBox6.Items[0];

  ComboBox7.Items.Add('East');
  ComboBox7.Items.Add('West');
  ComboBox7.Text := ComboBox7.Items[0];


  for I := 1 to 31 do begin
    str(i,s) ;
    ComboBox1.Items.Add(s);
  end;
  DateTimeToString(s,'d',today);
  ComboBox1.ItemIndex := StrToInt(s) - 1;

  ComboBox5.Items.Add('Jan');
  ComboBox5.Items.Add('Feb');
  ComboBox5.Items.Add('Mar');
  ComboBox5.Items.Add('Apr');
  ComboBox5.Items.Add('May');
  ComboBox5.Items.Add('Jun');
  ComboBox5.Items.Add('Jul');
  ComboBox5.Items.Add('Aug');
  ComboBox5.Items.Add('Sep');
  ComboBox5.Items.Add('Oct');
  ComboBox5.Items.Add('Nov');
  ComboBox5.Items.Add('Dec');
  ComboBox5.Text :=  ComboBox5.Items[0];
  DateTimeToString(s,'m',today);
  ComboBox5.ItemIndex := StrToInt(s) - 1;

  for I := 2000 to 2020 do begin
    str(i,s) ;
    ComboBox2.Items.Add(s);
  end;
  DateTimeToString(s,'yyyy',today);
  ComboBox2.ItemIndex := StrToInt(s) - 2000;

  r := GetTimezoneInformation(TZ);
  TimeZones[0] := 0;
	TimeZones[1] := 1;
  TimeZones[2] :=	2;
  TimeZones[3] := 3;
  TimeZones[4] := 3.5;
  TimeZones[5] := 4;
  TimeZones[6] := 4.5;
  TimeZones[7] := 5;
  TimeZones[8] := 5.5;
  TimeZones[9] := 6;
  TimeZones[10] := 6.5;
  TimeZones[11] := 7;
  TimeZones[12] := 8;
  TimeZones[13] := 9;
  TimeZones[14] := 9.5;
  TimeZones[15] := 10;
  TimeZones[16] := 10.5;
  TimeZones[17] := 11;
  TimeZones[18] := 11.5;
  TimeZones[19] := 12;
  TimeZones[20] := 13;
  TimeZones[21] := -1;
  TimeZones[22] := -2;
  TimeZones[23] := -3;
  TimeZones[24] := -3.5;
  TimeZones[25] := -4;
  TimeZones[26] := -5;
  TimeZones[27] := -6;
  TimeZones[28] := -7;
  TimeZones[29] := -8;
  TimeZones[30] := -8.5;
  TimeZones[31] := -9;
  TimeZones[32] := -9.5;
  TimeZones[33] := -10;
  TimeZones[34] := -11;
  TimeZones[35] := -12;
  ComboBox3.ItemIndex := 0;
  for I := 0 to length(TimeZones) - 1 do begin
    T := TimeZones[I];
    Str(T:0:1, s);
    if T = 0 then
      s := ''
    else begin
      if s[length(s)] = '0' then str(T:0:0, s);
      if T > 0 then s:= '+' + s;
    end;
    ComboBox3.Items.Add('GMT' + s);
    if TZ.Bias = - 60 * T then ComboBox3.ItemIndex := I;
  end;

  ComboBox4.Items.Add('No');
  ComboBox4.Items.Add('Yes');
  if r = TIME_ZONE_ID_DAYLIGHT then
    ComboBox4.Text := 'Yes'
  else
    ComboBox4.Text := 'No';

end;
end.
